Skip to content

For the complete documentation index, see llms.txt. Markdown versions of all docs pages are available by appending .md to any docs URL.

Solo Enterprise for kgateway APIs

Page as Markdown

Review the Solo Enterprise for kgateway API reference docs.

Packages

enterprisekgateway.solo.io/v1alpha1

Resource Types

AWSLambdaTransformFormat

Underlying type: string

AWSLambdaTransformFormat defines the format used to transform requests/responses to/from AWS Lambda functions.

Validation:

  • Enum: [APIGateway]

Appears in:

FieldDescription
APIGatewayAWSLambdaFormatAPIGateway transforms the request/response to/from AWS Lambda functions
as if it were handled by the AWS API Gateway.

AWSLambdaTransformation

AWSLambdaTransformation defines the AWS Lambda transformation configuration for requests and responses.

Appears in:

FieldDescriptionDefaultValidation
requestFormat AWSLambdaTransformFormatRequestFormat defines the format to transform requests to AWS Lambda functions.Enum: [APIGateway]
Optional: {}
responseFormat AWSLambdaTransformFormatResponseFormat defines the format to transform responses from AWS Lambda functions.Enum: [APIGateway]
Optional: {}

BodyTransformation

BodyTransformation defines how to transform the body.

Validation:

  • AtMostOneOf: [body mergeJsonKeys]

Appears in:

FieldDescriptionDefaultValidation
type BodyTransformationTypeType specifies the type of body transformation to apply.Enum: [Body Passthrough MergeExtractorsToBody MergeJsonKeys]
Required: {}
body InjaTemplateBody is the request/response body to be transformed. Only use when Type is Body.Optional: {}
mergeJsonKeys object (keys:string, values:OverridableTemplate)MergeJsonKeys is a transformation template used to merge json keys. Only use when Type is MergeJsonKeys.
A set of key-value pairs to merge into the JSON body.
Each value will be rendered separately, and then placed into the JSON body at
the specified key.
There are a number of important caveats to using this feature:
* This can only be used when the body is parsed as JSON.
* This option does NOT work with advanced templates currently
Map of key name -> template to render into the JSON body.
Specified keys which don’t exist in the JSON body will be set,
keys which do exist will be override.
For example, given the following JSON body:
{
“key1”: “value1”
}
and the following MergeJsonKeys:
{
“key1”: “{{ header(“header1”) }}”,
“key2”: “{{ header(“header2”) }}"
}
The resulting JSON body will be:
{
“key1”: “header1_value”,
“key2”: “header2_value”
}
Optional: {}

BodyTransformationType

Underlying type: string

BodyTransformationType defines the type of body transformation to apply.

Validation:

  • Enum: [Body Passthrough MergeExtractorsToBody MergeJsonKeys]

Appears in:

FieldDescription
BodyBodyTransformationTypeBody indicates a template-based body transformation
PassthroughBodyTransformationTypePassthrough indicates a passthrough body transformation
MergeExtractorsToBodyBodyTransformationTypeMergeExtractorsToBody indicates merging extractors to body
MergeJsonKeysBodyTransformationTypeMergeJsonKeys indicates merging JSON keys

ClaimToHeader

Allows copying verified claims to headers sent upstream

Appears in:

FieldDescriptionDefaultValidation
claim stringClaim name. for example, “sub”Required: {}
header stringThe header the claim will be copied to. for example, “x-sub”.Required: {}
append booleanIf the header exists, append to it (true), or overwrite it (false).
If omitted, will default to false.
Optional: {}

ContainerConfiguration

Appears in:

FieldDescriptionDefaultValidation
image ImageThe image. See https://kubernetes.io/docs/concepts/containers/images for
details.
Optional: {}
securityContext SecurityContextThe security context for this container. Note OmitSecurityContext and
FloatingUserId, two related settings. See
https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.26/#securitycontext-v1-core
for details.
Optional: {}

DeploymentConfiguration

DeploymentConfiguration configures the Kubernetes Deployment.

Appears in:

FieldDescriptionDefaultValidation
enabled booleanEnabled indicates whether the extension is enabled. If not enabled, then no resources for this extension will be deployed.
If the extension was previously enabled and then disabled, the deployed resources will be garbage collected, regardless of
whether any other configuration still depends on it.
Optional: {}
resources ResourceRequirementsOptional: {}
pod PodOptional: {}
container ContainerConfigurationOptional: {}
replicas integerThe number of desired pods.
If omitted, behavior will be managed by the K8s control plane, and will default to 1.
If you are using an HPA, make sure to not explicitly define this.
K8s reference: https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#replicas
Minimum: 0
Optional: {}
strategy DeploymentStrategyThe deployment strategy to use to replace existing pods with new
ones. The Kubernetes default is a RollingUpdate with 25% maxUnavailable,
25% maxSurge.
E.g., to recreate pods, minimizing resources for the rollout but causing downtime:
strategy:
type: Recreate
E.g., to roll out as a RollingUpdate but with non-default parameters:
strategy:
type: RollingUpdate
rollingUpdate:
maxSurge: 100%
Optional: {}
deploymentOverlay KubernetesResourceOverlayDeploymentOverlay allows specifying overrides for the generated Deployment resource.
Use this for advanced customization not covered by the typed config fields,
such as adding initContainers, sidecars, or removing security contexts for OpenShift.
Optional: {}
serviceOverlay KubernetesResourceOverlayServiceOverlay allows specifying overrides for the generated Service resource.Optional: {}
serviceAccountOverlay KubernetesResourceOverlayServiceAccountOverlay allows specifying overrides for the generated ServiceAccount resource.Optional: {}
podDisruptionBudget KubernetesResourceOverlayPodDisruptionBudget allows creating a PodDisruptionBudget for this extension.
If absent, no PDB is created. If present, a PDB is created with its selector
automatically configured to target the extension Deployment.
The metadata and spec fields from this overlay are applied to the generated PDB.
Optional: {}
horizontalPodAutoscaler KubernetesResourceOverlayHorizontalPodAutoscaler allows creating a HorizontalPodAutoscaler for this extension.
If absent, no HPA is created. If present, an HPA is created with its scaleTargetRef
automatically configured to target the extension Deployment.
The metadata and spec fields from this overlay are applied to the generated HPA.
Optional: {}
verticalPodAutoscaler KubernetesResourceOverlayVerticalPodAutoscaler allows creating a VerticalPodAutoscaler for this extension.
If absent, no VPA is created. If present, a VPA is created with its targetRef
automatically configured to target the extension Deployment.
The metadata and spec fields from this overlay are applied to the generated VPA.
Optional: {}

DynamicMetadataValue

DynamicMetadataValue defines an Envoy Dynamic Metadata entry.

Appears in:

FieldDescriptionDefaultValidation
metadataNamespace stringMetadataNamespace specifies the metadata namespace. Defaults to the filter namespace.MaxLength: 4096
MinLength: 1
Optional: {}
key stringKey specifies the metadata key.MaxLength: 4096
MinLength: 1
Required: {}
value InjaTemplateValue specifies the template that determines the metadata value.Required: {}
jsonToProto booleanJsonToProto determines whether to parse the rendered value as a proto Struct message.Optional: {}

EntExtAuth

Validation:

  • ExactlyOneOf: [authConfigRef disable]

Appears in:

FieldDescriptionDefaultValidation
authConfigRef AuthConfigRefAuthConfigRef references the AuthConfig we want the external-auth server will use to make auth
decisions.
Optional: {}
extensionRef NamespacedObjectReferenceExtensionRef references a GatewayExtension that provides the external authorization service.
If not set, defaults to the provisioned ext-auth-service for the GatewayClass of the parent Gateway
this policy is being used in.
Reference grants are not required for cross-namespace extension references.
Optional: {}
disable PolicyDisableDisable all external authorization filters.
Can be used to disable external authorization policies applied at a higher level in the config hierarchy.
Optional: {}

EntJWT

EntJWT defines a set of providers used for JWT authentication (and an optional validation policy for these providers) or the ability to disable JWT authentication and verification.

Appears in:

FieldDescriptionDefaultValidation
providers object (keys:string, values:JWTProvider)Providers maps a provider name to a JWT provider, configuring a way to authenticate JWTs.
If specified, multiple providers will be OR-ed together and will allow validation to any of the providers.
MaxProperties: 32
Optional: {}
validationPolicy JwtValidationPolicyConfigure how JWT validation works, with the flexibility to handle requests with missing or invalid JWTs.
By default, after applying a JWT policy, only requests that have been authenticated with a valid JWT are allowed.
Enum: [RequireValid AllowMissing AllowMissingOrFailed]
Optional: {}
disable PolicyDisableDisable JWT authentication for this policy scope.Optional: {}

EntRBAC

EntRBAC defines RBAC configuration.

Validation:

  • ExactlyOneOf: [disable policies]

Appears in:

FieldDescriptionDefaultValidation
disable PolicyDisableDisable is used to explicitly disable RBAC checks for the scope of this policy.
This is useful to allow access to static resources/login page without RBAC checks.
Optional: {}
policies object (keys:string, values:RBACPolicy)Policies maps a policy name to an RBAC policy to apply.Optional: {}

EntRateLimit

Appears in:

FieldDescriptionDefaultValidation
global GlobalRateLimitGlobal rate limit configurationRequired: {}

EntTransformation

EntTransformation defines the Enterprise transformation configuration.

Appears in:

FieldDescriptionDefaultValidation
stages StagedTransformationsStages defines the transformations run at different stages of the filter chain.Optional: {}
awsLambda AWSLambdaTransformationAWSLambda defines the AWS Lambda transformation configuration.Optional: {}

EntWAF

Validation:

  • AtMostOneOf: [wafServerRef disable]
  • ExactlyOneOf: [wafPolicyRef disable]

Appears in:

FieldDescriptionDefaultValidation
wafPolicyRef WAFPolicyRefWAFPolicyRef references the WAFPolicy we want to use for the traffic policyOptional: {}
wafServerRef BackendObjectReferenceWAFServerRef is a reference to the external processing gRPC service that will be used to process requests
when WAF is enabled.
If not set, defaults to the extproc service named ‘waf-server’ in the same namespace as
the Solo Enterprise for kgateway control plane.
Optional: {}
disable PolicyDisableDisable WAF.
Can be used to disable WAF policies applied at a higher level in the config hierarchy.
Optional: {}

EnterpriseKgatewayKubernetesProxyConfig

Appears in:

Inherits fields from:

  • GatewayParametersOverlays
    FieldDescriptionDefaultValidation
    deployment ProxyDeploymentUse a Kubernetes deployment as the proxy workload type. Currently, this is the only
    supported workload type.
    Optional: {}
    envoyContainer EnvoyContainerConfiguration for the container running Envoy.
    If agentgateway is enabled, the EnvoyContainer values will be ignored.
    Optional: {}
    sdsContainer SdsContainerConfiguration for the container running the Secret Discovery Service (SDS).Optional: {}
    podTemplate PodConfiguration for the pods that will be created.Optional: {}
    service ServiceConfiguration for the Kubernetes Service that exposes the Envoy proxy over
    the network.
    Optional: {}
    serviceAccount ServiceAccountConfiguration for the Kubernetes ServiceAccount used by the Envoy pod.Optional: {}
    istio IstioIntegrationConfiguration for the Istio integration.Optional: {}
    stats StatsConfigConfiguration for the stats server.Optional: {}
    omitDefaultSecurityContext booleanOmitDefaultSecurityContext is used to control whether or not
    securityContext fields should be rendered for the various generated
    Deployments/Containers that are dynamically provisioned by the deployer.
    When set to true, no securityContexts will be provided and will left
    to the user/platform to be provided.
    This should be enabled on platforms such as Red Hat OpenShift where the
    securityContext will be dynamically added to enforce the appropriate
    level of security.
    Optional: {}
    deploymentOverlay KubernetesResourceOverlaydeploymentOverlay allows specifying overrides for the generated Deployment resource.Optional: {}
    serviceOverlay KubernetesResourceOverlayserviceOverlay allows specifying overrides for the generated Service resource.Optional: {}
    serviceAccountOverlay KubernetesResourceOverlayserviceAccountOverlay allows specifying overrides for the generated ServiceAccount resource.Optional: {}
    podDisruptionBudget KubernetesResourceOverlaypodDisruptionBudget allows creating a PodDisruptionBudget for the proxy.
    If absent, no PDB is created. If present, a PDB is created with its selector
    automatically configured to target the proxy Deployment.
    The metadata and spec fields from this overlay are applied to the generated PDB.
    Optional: {}
    horizontalPodAutoscaler KubernetesResourceOverlayhorizontalPodAutoscaler allows creating a HorizontalPodAutoscaler for the proxy.
    If absent, no HPA is created. If present, an HPA is created with its scaleTargetRef
    automatically configured to target the proxy Deployment.
    The metadata and spec fields from this overlay are applied to the generated HPA.
    Optional: {}
    verticalPodAutoscaler KubernetesResourceOverlayverticalPodAutoscaler allows creating a VerticalPodAutoscaler for the proxy.
    If absent, no VPA is created. If present, a VPA is created with its targetRef
    automatically configured to target the proxy Deployment.
    The metadata and spec fields from this overlay are applied to the generated VPA.
    Optional: {}
    sharedExtensions ExtensionsSharedExtensions defines extensions that are shared across all Gateways of the same GatewayClassOptional: {}

EnterpriseKgatewayParameters

EnterpriseKgatewayParameters contains configuration that is used to dynamically provision Solo Enterprise for kgateway’s data plane (Envoy proxy instance), and enterprise ExtAuth and RateLimiter extensions

Inherits fields from:

EnterpriseKgatewayParametersSpec

EnterpriseKgatewayParametersSpec defines the desired state of EnterpriseKgatewayParameters

Appears in:

FieldDescriptionDefaultValidation
kube EnterpriseKgatewayKubernetesProxyConfigKubernetes configuration for the proxy.Optional: {}

EnterpriseKgatewayParametersStatus

Appears in:

EnterpriseKgatewayTrafficPolicy

EnterpriseKgatewayTrafficPolicy is a traffic policy that can be applied to a route

Inherits fields from:

EnterpriseKgatewayTrafficPolicySpec

EnterpriseKgatewayTrafficPolicySpec defines the desired state of EnterpriseKgatewayTrafficPolicy

Validation:

  • AtMostOneOf: [transformation entTransformation]

Appears in:

Inherits fields from:

  • TrafficPolicySpec
    FieldDescriptionDefaultValidation
    targetRefs LocalPolicyTargetReferenceWithSectionName arrayTargetRefs specifies the target resources by reference to attach the policy to.MaxItems: 16
    MinItems: 1
    Optional: {}
    targetSelectors LocalPolicyTargetSelectorWithSectionName arrayTargetSelectors specifies the target selectors to select resources to attach the policy to.Optional: {}
    transformation TransformationPolicyTransformation is used to mutate and transform requests and responses
    before forwarding them to the destination.
    Optional: {}
    extProc ExtProcPolicyExtProc specifies the external processing configuration for the policy.ExactlyOneOf: [extensionRef disable]
    Optional: {}
    extAuth ExtAuthPolicyExtAuth specifies the external authentication configuration for the policy.
    This controls what external server to send requests to for authentication.
    ExactlyOneOf: [extensionRef disable]
    Optional: {}
    rateLimit RateLimitRateLimit specifies the rate limiting configuration for the policy.
    This controls the rate at which requests are allowed to be processed.
    Optional: {}
    cors CorsPolicyCors specifies the CORS configuration for the policy.Optional: {}
    csrf CSRFPolicyCsrf specifies the Cross-Site Request Forgery (CSRF) policy for this traffic policy.AtMostOneOf: [percentageEnabled percentageShadowed]
    Optional: {}
    headerModifiers HeaderModifiersHeaderModifiers defines the policy to modify request and response headers.Optional: {}
    autoHostRewrite booleanAutoHostRewrite rewrites the Host header to the DNS name of the selected upstream.
    NOTE: This field is only honored for HTTPRoute targets.
    NOTE: If autoHostRewrite is set on a route that also has a URLRewrite filter
    configured to override the hostname, the hostname value will be used and autoHostRewrite will be ignored.
    Optional: {}
    buffer BufferBuffer can be used to set the maximum request size that will be buffered.
    Requests exceeding this size will return a 413 response.
    ExactlyOneOf: [maxRequestSize disable]
    Optional: {}
    timeouts TimeoutsTimeouts defines the timeouts for requests
    It is applicable to HTTPRoutes and ignored for other targeted kinds.
    Optional: {}
    retry RetryRetry defines the policy for retrying requests.
    It is applicable to HTTPRoutes, Gateway listeners and ListenerSets, and ignored for other targeted kinds.
    Optional: {}
    rbac AuthorizationRBAC specifies the role-based access control configuration for the policy.
    This defines the rules for authorization based on roles and permissions.
    RBAC policies applied at different attachment points in the configuration
    hierarchy are not cumulative, and only the most specific policy is enforced. This means an RBAC policy
    attached to a route will override any RBAC policies applied to the gateway or listener.
    Optional: {}
    jwtAuth JWTAuthJWT specifies the JWT authentication configuration for the policy.
    This defines the JWT providers and their configurations.
    ExactlyOneOf: [extensionRef disable]
    Optional: {}
    urlRewrite URLRewriteUrlRewrite specifies URL rewrite rules for matching requests.
    NOTE: This field is only honored for HTTPRoute targets.
    AtLeastOneOf: [pathRegex]
    Optional: {}
    compression CompressionCompression configures response compression (per-route) and request/response
    decompression (listener-level insertion triggered by route enable).
    The response compression configuration is only honored for HTTPRoute targets.
    AtLeastOneOf: [responseCompression requestDecompression]
    Optional: {}
    basicAuth BasicAuthPolicyBasicAuth specifies the HTTP basic authentication configuration for the policy.
    This controls authentication using username/password credentials in the Authorization header.
    ExactlyOneOf: [users secretRef disable]
    Optional: {}
    apiKeyAuth APIKeyAuthAPIKeyAuth authenticates users based on a configured API Key.ExactlyOneOf: [secretRef secretSelector disable]
    Optional: {}
    oauth2 OAuth2PolicyOAuth2 specifies the configuration to use for OAuth2/OIDC.
    Note: the OAuth2 filter does not protect against Cross-Site-Request-Forgery attacks on domains with cached
    authentication (in the form of cookies). It is recommended to pair this with the CSRF policy to prevent
    malicious social engineering.
    Optional: {}
    tracing RouteTracingTracing configures per-route tracing overrides.
    These settings override the listener-level tracing configuration
    (configured via ListenerPolicy) for matched routes.
    The tracing provider (e.g., OpenTelemetry collector endpoint) must be
    configured at the listener level via ListenerPolicy. Without a listener-level
    tracing provider, route-level settings have no effect.
    NOTE: This field is only honored for HTTPRoute and GRPCRoute targets.
    Optional: {}
    faultInjection FaultInjectionPolicyFaultInjection configures fault injection for chaos engineering and
    resiliency testing. Supports delay injection, abort injection,
    and response rate limiting.
    AtLeastOneOf: [delay abort responseRateLimit disable]
    Optional: {}
    acl ACLPolicyACL configures IP-based access control for HTTP requests.
    Rules are evaluated using longest-prefix matching on the effictive client IP
    from envoy base on settings. See the UseRemoteAddress, XffTrustedCIDRs,
    XffNumTrustedHops settings under ListenerPolicy -> HttpSettings for details.
    Optional: {}
    entRateLimit EntRateLimitEntRateLimit defines the Enterprise rate limit configuration for the traffic policyOptional: {}
    entExtAuth EntExtAuthEntExtAuth defines the Enterprise external authorization configuration for the traffic policyExactlyOneOf: [authConfigRef disable]
    Optional: {}
    entTransformation EntTransformationEntTransformation defines the Enterprise transformation configuration for the traffic policyOptional: {}
    entJWT StagedJWTEntJWT allows for configuration of JWT authenticationOptional: {}
    entRBAC EntRBACEntRBAC provides config for RBAC rules based on JWT claims resulting from authentication with entJWT configsExactlyOneOf: [disable policies]
    Optional: {}
    entWAF EntWAFEntWAF defines the Web Application Firewall configurationAtMostOneOf: [wafServerRef disable]
    ExactlyOneOf: [wafPolicyRef disable]
    Optional: {}

EscapeCharactersBehavior

Underlying type: string

EscapeCharactersBehavior defines how to handle characters that need to be escaped in JSON.

Validation:

  • Enum: [Escape DontEscape]

Appears in:

FieldDescription
EscapeEscapeCharactersEscape always escapes characters that need to be escaped in JSON
DontEscapeEscapeCharactersDontEscape never escapes characters

ExtAuthConfiguration

ExtAuthConfiguration configures the ExtAuth server deployment.

Appears in:

FieldDescriptionDefaultValidation
enabled boolean(Inherited from DeploymentConfiguration) Enabled indicates whether the extension is enabled. If not enabled, then no resources for this extension will be deployed.
If the extension was previously enabled and then disabled, the deployed resources will be garbage collected, regardless of
whether any other configuration still depends on it.
Optional: {}
resources ResourceRequirements(Inherited from DeploymentConfiguration)Optional: {}
pod Pod(Inherited from DeploymentConfiguration)Optional: {}
container ContainerConfiguration(Inherited from DeploymentConfiguration)Optional: {}
replicas integer(Inherited from DeploymentConfiguration) The number of desired pods.
If omitted, behavior will be managed by the K8s control plane, and will default to 1.
If you are using an HPA, make sure to not explicitly define this.
K8s reference: https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#replicas
Minimum: 0
Optional: {}
strategy DeploymentStrategy(Inherited from DeploymentConfiguration) The deployment strategy to use to replace existing pods with new
ones. The Kubernetes default is a RollingUpdate with 25% maxUnavailable,
25% maxSurge.
E.g., to recreate pods, minimizing resources for the rollout but causing downtime:
strategy:
type: Recreate
E.g., to roll out as a RollingUpdate but with non-default parameters:
strategy:
type: RollingUpdate
rollingUpdate:
maxSurge: 100%
Optional: {}
deploymentOverlay KubernetesResourceOverlay(Inherited from DeploymentConfiguration) DeploymentOverlay allows specifying overrides for the generated Deployment resource.
Use this for advanced customization not covered by the typed config fields,
such as adding initContainers, sidecars, or removing security contexts for OpenShift.
Optional: {}
serviceOverlay KubernetesResourceOverlay(Inherited from DeploymentConfiguration) ServiceOverlay allows specifying overrides for the generated Service resource.Optional: {}
serviceAccountOverlay KubernetesResourceOverlay(Inherited from DeploymentConfiguration) ServiceAccountOverlay allows specifying overrides for the generated ServiceAccount resource.Optional: {}
podDisruptionBudget KubernetesResourceOverlay(Inherited from DeploymentConfiguration) PodDisruptionBudget allows creating a PodDisruptionBudget for this extension.
If absent, no PDB is created. If present, a PDB is created with its selector
automatically configured to target the extension Deployment.
The metadata and spec fields from this overlay are applied to the generated PDB.
Optional: {}
horizontalPodAutoscaler KubernetesResourceOverlay(Inherited from DeploymentConfiguration) HorizontalPodAutoscaler allows creating a HorizontalPodAutoscaler for this extension.
If absent, no HPA is created. If present, an HPA is created with its scaleTargetRef
automatically configured to target the extension Deployment.
The metadata and spec fields from this overlay are applied to the generated HPA.
Optional: {}
verticalPodAutoscaler KubernetesResourceOverlay(Inherited from DeploymentConfiguration) VerticalPodAutoscaler allows creating a VerticalPodAutoscaler for this extension.
If absent, no VPA is created. If present, a VPA is created with its targetRef
automatically configured to target the extension Deployment.
The metadata and spec fields from this overlay are applied to the generated VPA.
Optional: {}
sessionRedis RedisClientConfigSessionRedis configures the server-level default Redis connection for
ExtAuth session storage (OAuth2/OIDC). When specified, individual
AuthConfig CRs do not need to repeat connection details in their
RedisOptions fields, though per-AuthConfig overrides are still supported.
Optional: {}
serviceAccountName stringServiceAccountName sets the serviceAccountName on the generated ExtAuth
Deployment. Use this to attach a ServiceAccount configured for AWS
credentials, such as through IRSA or EKS Pod Identity, for AWS
ElastiCache IAM authentication.
Optional: {}

Extensions

Appears in:

FieldDescriptionDefaultValidation
extauth ExtAuthConfigurationOptional: {}
ratelimiter RateLimiterConfigurationOptional: {}
extCache DeploymentConfigurationOptional: {}
waf WAFConfigurationWAF configures the WAF server.Optional: {}

Extraction

Extraction is used to define extractions to extract information from the request/response. The extracted information can then be referenced in template fields.

Validation:

  • AtMostOneOf: [body header]

Appears in:

FieldDescriptionDefaultValidation
body booleanExtractionBody specifies extracting information from the request/response body.Optional: {}
header stringExtractionHeader specifies extracting information from headers.MaxLength: 4096
MinLength: 1
Optional: {}
regex stringRegex specifies the regular expression used for matching against the source content.
- In Extract mode, the entire source must match the regex. subgroup selects the n-th capturing group,
which determines the part of the match that you want to extract. If the regex does not match the source,
the result of the extraction will be an empty value.
- In SingleReplace mode, the regex also needs to match the entire source. subgroup selects the n-th capturing group
that is replaced with the content of replacementText. If the regex does not match the source, the result
of the replacement will be the source itself.
- In ReplaceAll mode, the regex is applied repeatedly to find all occurrences within the source that match.
Each matching occurrence is replaced with the value in replacementText. In this mode, the configuration is rejected
if subgroup is set. If the regex does not match the source, the result of the replacement will be the source itself.
MaxLength: 4096
MinLength: 1
Required: {}
subgroup integerSubgroup is used to determine the group that you want to select if your regex contains capturing groups. Defaults to 0.
If set in Extract and SingleReplace modes, the subgroup represents the capturing
group that you want to extract or replace in the source.
The configuration is rejected if you set subgroup to a non-zero value when using the REPLACE_ALL mode.
Minimum: 0
Optional: {}
replacementText stringReplacementText is used to format the substitution for matched sequences in
an input string. This value is only legal in SingleReplace and REPLACE_ALL modes.
- In SingleReplace mode, the subgroup selects the n-th capturing group, which represents
the value that you want to replace with the string provided in replacementText.
- In REPLACE_ALL mode, each sequence that matches the specified regex in the input is
replaced with the value inreplacementText.
The replacementText can include special syntax, such as $1, $2, etc., to refer to
capturing groups within the regular expression.
The value that is specified in replacementText is treated as a string, and is passed
to std::regex_replace as the replacement string.
For more information, see https://en.cppreference.com/w/cpp/regex/regex_replace.
Optional: {}
mode TransformationExtractModeMode defines the mode of operation for the extraction.
Defaults to Extract.
ExtractEnum: [Extract SingleReplace ReplaceAll]
Optional: {}

GlobalRateLimit

Appears in:

FieldDescriptionDefaultValidation
extensionRef NamespacedObjectReferenceExtensionRef references a GatewayExtension that provides the global rate limit service.
If not set, defaults to the rate limit service named ‘rate-limit’ in the same namespace as
the Solo Enterprise for kgateway control plane. In this case no reference grant is required.
Optional: {}
rateLimitConfigRefs RateLimitConfigRef arrayRateLimitConfigRefs is a list of references to the RateLimitConfig resources containing the
rate limit configurations.
MaxItems: 16
MinItems: 1
Required: {}

HeaderBodyTransform

HeaderBodyTransform defines a header and body transformation.

Appears in:

FieldDescriptionDefaultValidation
addRequestMetadata booleanAddRequestMetadata determines whether to add request metadata to the body.
When transforming a request, setting this to true will additionally add “queryString”,
“queryStringParameters”, “multiValueQueryStringParameters”, “httpMethod”, “path”,
and “multiValueHeaders” to the body.
Optional: {}

HeaderToAppend

HeaderToAppend defines a header-template pair for appending headers.

Appears in:

FieldDescriptionDefaultValidation
key stringKey specifies the header name.MaxLength: 4096
MinLength: 1
Required: {}
value InjaTemplateValue specifies the template to apply to the header value.Required: {}

InjaTemplate

Underlying type: string

InjaTemplate defines an Inja template that will be rendered by Gloo. In addition to the core template functions, the Gloo transformation filter defines the following custom functions:

  • header(header_name): returns the value of the header with the given name.
  • extraction(extractor_name): returns the value of the extractor with the given name.
  • env(env_var_name): returns the value of the environment variable with the given name.
  • body(): returns the request/response body.
  • context(): returns the base JSON context (allowing for example to range on a JSON body that is an array).
  • request_header(header_name): returns the value of the request header with the given name. Use this option when you want to include request header values in response transformations.
  • base64_encode(string): encodes the input string to base64.
  • base64_decode(string): decodes the input string from base64.
  • substring(string, start_pos, substring_len): returns a substring of the input string, starting at start_pos and extending for substring_len characters. If no substring_len is provided or substring_len is <= 0, the substring extends to the end of the input string.

Appears in:

JWKS

JWKS (JSON Web Key Set) configures how to fetch the public key used for JWT verification.

Validation:

  • ExactlyOneOf: [local remote]

Appears in:

FieldDescriptionDefaultValidation
local LocalJWKSLocal is used when JWKS is local to the proxy, such as an inline string definition.Optional: {}
remote RemoteJWKSRemote is used when the JWKS should be fetched from a remote hostOptional: {}

JWTProvider

JWTProvider defines configuration for how a JWT should be authenticated and verified.

Appears in:

FieldDescriptionDefaultValidation
jwks JWKSThe source for the keys to validate JWTs.ExactlyOneOf: [local remote]
Required: {}
audiences string arrayAn incoming JWT must have an ‘aud’ claim and it must be in this list.Optional: {}
issuer stringIssuer of the JWT. the ‘iss’ claim of the JWT must match this.Optional: {}
tokenSource TokenSourceWhere to find the JWT of the current provider.Optional: {}
keepToken booleanShould the token forwarded upstream. If false, the header containing the token will be removed.
If omitted, the default behavior is to remove the token and not forward
Optional: {}
claimsToHeaders ClaimToHeader arrayWhat claims should be copied to upstream headers.Optional: {}
clockSkewSeconds integerUsed to verify time constraints, such as exp and npf. If omitted, defaults to 60sMinimum: 0
Optional: {}
attachFailedStatusToMetadata stringWhen this field is set, the specified value is used as the key in DynamicMetadata to store the JWT failure status code
and message under that key. This field is particularly useful when logging the failure status.
For example, if the value of attach_failed_status_to_metadata is ‘custom_auth_failure_status’ then
the failure status can be accessed in the access log as ‘%DYNAMIC_METADATA(envoy.filters.http.jwt_authn:custom_auth_failure_status)’
Note: status code and message can be individually accessed as ‘%DYNAMIC_METADATA(envoy.filters.http.jwt_authn:custom_auth_failure_status.code)’ and ‘%DYNAMIC_METADATA(envoy.filters.http.jwt_authn:custom_auth_failure_status.message)’ respectively.
Optional: {}

JwksAsyncFetch

Fetch Jwks asynchronously in the main thread when the filter config is parsed. The listener is activated only after the Jwks is fetched. When the Jwks is expired in the cache, it is fetched again in the main thread. The fetched Jwks from the main thread can be used by all worker threads.

Appears in:

FieldDescriptionDefaultValidation
fastListener booleanIf false, the listener is activated after the initial fetch is completed.
The initial fetch result can be either successful or failed.
If true, it is activated without waiting for the initial fetch to complete.
Default is false.
Optional: {}

JwtValidationPolicy

Underlying type: string

Validation:

  • Enum: [RequireValid AllowMissing AllowMissingOrFailed]

Appears in:

FieldDescription
RequireValidDefault value. Allow only requests that authenticate with a valid JWT to succeed.
AllowMissingAllow requests to succeed even if JWT authentication is missing, but fail when an invalid JWT token is presented.
You might use this setting when later steps depend on input from the JWT.
For example, you might add claims from the JWT to request headers with the claimsToHeaders field.
As such, you may want to make sure that any provided JWT is valid. If not, the request fails,
which informs the requester that their JWT is not valid.
Requests without a JWT, however, still succeed and skip JWT validation.
AllowMissingOrFailedAllow requests to succeed even when a JWT is missing or JWT verification fails.
For example, you might apply multiple policies to your routes so that requests can authenticate with either a
JWT or another method such as external auth. Use this value
to allow a failed JWT auth request to pass through to the other authentication method.

LocalJWKS

LocalJWKS contains configuration for JWKS that are locally available to the proxy

Appears in:

FieldDescriptionDefaultValidation
key stringInline key. this can be json web key, key-set or PEM format.Required: {}

OverridableTemplate

Appears in:

FieldDescriptionDefaultValidation
tmpl InjaTemplateTemplate to renderRequired: {}
overrideEmpty booleanIf set to true, the template will be set even if the rendered value is empty.Optional: {}

QueryParameterMatcher

QueryParameterMatcher configures the query parameter matching to apply.

Appears in:

FieldDescriptionDefaultValidation
name stringSpecifies the name of a key that must be present in the requested
path’s query string.
Required: {}
value stringSpecifies the value of the key. If the value is absent, a request
that contains the key in its query string will match, whether the
key appears with a value (e.g., “?debug=true”) or not (e.g., “?debug”)
Optional: {}
regex booleanSpecifies whether the query parameter value is a regular expression.
Defaults to false. The entire query parameter value (i.e., the part to
the right of the equals sign in “key=value”) must match the regex.
E.g., the regex “\d+$” will match “123” but not “a123” or “123a”.
Optional: {}

RBACJWTPrincipal

A JWT principal. To use this, JWT authentication MUST be configured as well.

Appears in:

FieldDescriptionDefaultValidation
claims object (keys:string, values:string)Set of claims that make up this principal. Commonly, the ‘iss’ and ‘sub’ or ’email’ claims are used.
If you specify the path for a nested claim, such as ‘parent.child.foo’, you must also specify
a non-empty string value for the nested_claim_delimiter field in the Policy.
Required: {}
provider stringVerify that the JWT came from a specific provider. This usually can be left empty
and a provider will be chosen automatically.
MinLength: 1
Optional: {}
matcher RBACJWTPrincipalClaimMatcherThe matcher to use when evaluating this principal. If omitted, exact string comparison (ExactString) is used.Enum: [ExactString Boolean ListContains SpaceDelimitedStringContains]
Optional: {}

RBACJWTPrincipalClaimMatcher

Underlying type: string

Appears in:

FieldDescription
ExactStringThe JWT claim value is a string that exactly matches the value.
BooleanThe JWT claim value is a boolean that matches the value.
ListContainsThe JWT claim value is a list that contains a string that exactly matches the value.
SpaceDelimitedStringContainsThe JWT claim value is a space-delimited string that contains one or more tokens.
Multiple tokens are matched with AND logic (all must be present).

RBACPermissions

What permissions should be granted. An empty field means allow-all. If more than one field is added, all of them need to match.

Appears in:

FieldDescriptionDefaultValidation
pathPrefix stringPaths that have this prefix will be allowed.MinLength: 1
Optional: {}
methods string arrayWhat http methods (GET, POST, …) are allowed.Optional: {}

RBACPolicy

Appears in:

FieldDescriptionDefaultValidation
principals RBACPrincipal arrayPrincipals in this policy.MinItems: 1
Required: {}
permissions RBACPermissionsPermissions granted to the principals.Optional: {}
nestedClaimDelimiter stringThe delimiter to use when specifying nested claim names within principals.
Default is an empty string, which disables nested claim functionality.
This is commonly set to ., allowing for nested claim names of the form
parent.child.grandchild
Optional: {}

RBACPrincipal

An RBAC principal - the identity entity (usually a user or a service account).

Appears in:

FieldDescriptionDefaultValidation
jwtPrincipal RBACJWTPrincipalJWTPrincipal references a principal from JWT authentication.Required: {}

RateLimiterConfiguration

RateLimiterConfiguration configures the RateLimit server deployment.

Appears in:

FieldDescriptionDefaultValidation
enabled boolean(Inherited from DeploymentConfiguration) Enabled indicates whether the extension is enabled. If not enabled, then no resources for this extension will be deployed.
If the extension was previously enabled and then disabled, the deployed resources will be garbage collected, regardless of
whether any other configuration still depends on it.
Optional: {}
resources ResourceRequirements(Inherited from DeploymentConfiguration)Optional: {}
pod Pod(Inherited from DeploymentConfiguration)Optional: {}
container ContainerConfiguration(Inherited from DeploymentConfiguration)Optional: {}
replicas integer(Inherited from DeploymentConfiguration) The number of desired pods.
If omitted, behavior will be managed by the K8s control plane, and will default to 1.
If you are using an HPA, make sure to not explicitly define this.
K8s reference: https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#replicas
Minimum: 0
Optional: {}
strategy DeploymentStrategy(Inherited from DeploymentConfiguration) The deployment strategy to use to replace existing pods with new
ones. The Kubernetes default is a RollingUpdate with 25% maxUnavailable,
25% maxSurge.
E.g., to recreate pods, minimizing resources for the rollout but causing downtime:
strategy:
type: Recreate
E.g., to roll out as a RollingUpdate but with non-default parameters:
strategy:
type: RollingUpdate
rollingUpdate:
maxSurge: 100%
Optional: {}
deploymentOverlay KubernetesResourceOverlay(Inherited from DeploymentConfiguration) DeploymentOverlay allows specifying overrides for the generated Deployment resource.
Use this for advanced customization not covered by the typed config fields,
such as adding initContainers, sidecars, or removing security contexts for OpenShift.
Optional: {}
serviceOverlay KubernetesResourceOverlay(Inherited from DeploymentConfiguration) ServiceOverlay allows specifying overrides for the generated Service resource.Optional: {}
serviceAccountOverlay KubernetesResourceOverlay(Inherited from DeploymentConfiguration) ServiceAccountOverlay allows specifying overrides for the generated ServiceAccount resource.Optional: {}
podDisruptionBudget KubernetesResourceOverlay(Inherited from DeploymentConfiguration) PodDisruptionBudget allows creating a PodDisruptionBudget for this extension.
If absent, no PDB is created. If present, a PDB is created with its selector
automatically configured to target the extension Deployment.
The metadata and spec fields from this overlay are applied to the generated PDB.
Optional: {}
horizontalPodAutoscaler KubernetesResourceOverlay(Inherited from DeploymentConfiguration) HorizontalPodAutoscaler allows creating a HorizontalPodAutoscaler for this extension.
If absent, no HPA is created. If present, an HPA is created with its scaleTargetRef
automatically configured to target the extension Deployment.
The metadata and spec fields from this overlay are applied to the generated HPA.
Optional: {}
verticalPodAutoscaler KubernetesResourceOverlay(Inherited from DeploymentConfiguration) VerticalPodAutoscaler allows creating a VerticalPodAutoscaler for this extension.
If absent, no VPA is created. If present, a VPA is created with its targetRef
automatically configured to target the extension Deployment.
The metadata and spec fields from this overlay are applied to the generated VPA.
Optional: {}
redis RedisClientConfigRedis configures the Redis connection for the RateLimit server.
When specified, the RateLimit server connects to this Redis instance
instead of the managed ext-cache Redis.
Optional: {}
serviceAccountName stringServiceAccountName sets the serviceAccountName on the generated RateLimit
Deployment. Use this to attach a ServiceAccount configured for AWS
credentials, such as through IRSA or EKS Pod Identity, for AWS
ElastiCache IAM authentication.
Optional: {}

RedisAWSAuth

RedisAWSAuth configures AWS ElastiCache IAM authentication. Requires the pod to have AWS credentials, such as through IRSA or EKS Pod Identity.

Appears in:

FieldDescriptionDefaultValidation
region stringRegion is the AWS region of the ElastiCache cluster.Required: {}
clusterName stringClusterName is the ElastiCache replication group ID.Required: {}
userName stringUserName is the ElastiCache user ID with IAM authentication enabled.Required: {}
serverlessCacheName stringServerlessCacheName is the AWS ElastiCache Serverless cache name used in
the IAM token signature. Set this for Serverless ElastiCache deployments;
the value is distinct from Address (which remains the Redis endpoint
host:port). Leave unset for provisioned ElastiCache clusters.
Optional: {}

RedisAuth

RedisAuth configures authentication for a Redis connection. This is a discriminated union: specify exactly one of secretRef or aws.

Validation:

  • ExactlyOneOf: [secretRef aws]

Appears in:

FieldDescriptionDefaultValidation
secretRef RedisSecretAuthSecretRef configures static credential authentication using a Kubernetes Secret
containing username and password.
Optional: {}
aws RedisAWSAuthAWS configures AWS ElastiCache IAM authentication.
No static credentials are stored; tokens are generated at runtime
using AWS credentials available to the pod.
Optional: {}

RedisCerts

RedisCerts configures TLS certificates for the Redis connection.

Appears in:

FieldDescriptionDefaultValidation
caCertSecretRef SecretReferenceCACertSecretRef references a Kubernetes Secret containing the CA certificate
for verifying the Redis server’s TLS certificate.
Optional: {}
caCertKey stringCACertKey is the key within the Secret that contains the CA certificate in PEM format.
Defaults to “ca.crt” if not specified.
Optional: {}

RedisClientConfig

RedisClientConfig is a reusable Redis connection configuration structure shared by both the RateLimit and ExtAuth sections of EnterpriseKgatewayParameters.

Appears in:

FieldDescriptionDefaultValidation
address stringAddress is the Redis server address in “host:port” format, or a Unix
socket path when socketType is “unix”.
Examples: “redis.example.com:6379”, “my-redis.default.svc.cluster.local:6379”, “/var/run/redis/redis.sock”
Required: {}
db integerDB is the Redis database index.
Defaults to 0 if not specified.
Minimum: 0
Optional: {}
socketType stringSocketType specifies the connection type: “tcp”, “tls”, or “unix”.
Defaults to “tcp” if not specified.
Enum: [tcp tls unix]
Optional: {}
clustered booleanClustered enables Redis Cluster mode.
When true, the client uses a ClusterClient that handles MOVED/ASK redirects.
Optional: {}
certs RedisCertsCerts configures TLS certificates for the Redis connection.
Only applicable when SocketType is “tls”.
Optional: {}
auth RedisAuthAuth configures authentication for the Redis connection.
Exactly one of secretRef or aws should be specified.
If not specified, no authentication is used.
ExactlyOneOf: [secretRef aws]
Optional: {}
connection RedisConnectionConfigConnection configures connection pool and timeout tuning parameters.
When not specified, Redis client library defaults apply.
Optional: {}

RedisConnectionConfig

RedisConnectionConfig configures connection pool and timeout tuning for Redis.

Appears in:

FieldDescriptionDefaultValidation
poolSize integerPoolSize is the maximum number of connections in the pool.Minimum: 1
Optional: {}
minIdleConns integerMinIdleConns is the minimum number of idle connections in the pool.Minimum: 0
Optional: {}
maxIdleConns integerMaxIdleConns is the maximum number of idle connections in the pool.Minimum: 0
Optional: {}
dialTimeout DurationDialTimeout is the timeout for establishing new connections.Optional: {}
readTimeout DurationReadTimeout is the timeout for reading a single command reply.Optional: {}
writeTimeout DurationWriteTimeout is the timeout for writing a single command.Optional: {}
poolTimeout DurationPoolTimeout is the time to wait for a connection from the pool
when all connections are busy.
Optional: {}
connMaxIdleTime DurationConnMaxIdleTime is the maximum time a connection may be idle before
being closed.
Optional: {}
connMaxLifetime DurationConnMaxLifetime is the maximum lifetime of a connection before it is
closed and recreated, regardless of activity.
Optional: {}
maxRetries integerMaxRetries is the maximum number of retries on failed commands.Minimum: 0
Optional: {}
minRetryBackoff DurationMinRetryBackoff is the minimum backoff interval between retries.Optional: {}
maxRetryBackoff DurationMaxRetryBackoff is the maximum backoff interval between retries.Optional: {}

RedisSecretAuth

RedisSecretAuth configures Redis authentication from a Kubernetes Secret.

Appears in:

FieldDescriptionDefaultValidation
name stringName is the name of the Kubernetes Secret containing Redis credentials.Required: {}
namespace stringNamespace is the namespace of the Secret. If not specified, the Secret
is assumed to be in the same namespace as the extension Deployment.
Optional: {}
passwordKey stringPasswordKey is the key in the Secret that contains the Redis password.
Defaults to “password” if not specified.
Optional: {}
usernameKey stringUsernameKey is the key in the Secret that contains the Redis username.
Defaults to “username” if not specified.
Optional: {}

RegexMatcher

RegexMatcher based on https://github.com/envoyproxy/envoy/blob/4453ce1f809ec502fb2cbe0363cf5c6a971f3836/api/envoy/type/matcher/regex.proto#L19

Appears in:

FieldDescriptionDefaultValidation
regex stringThe regex match string. The string must be supported by the configured engine.Required: {}

RemoteJWKS

Appears in:

FieldDescriptionDefaultValidation
url stringThe url used when accessing the upstream for Json Web Key Set.
This is used to correctly set the host and path in the JWKS HTTP request.
E.g. https://example.com/.well-known/jwks.json
Pattern: ^(http|https):\/\/[a-zA-Z0-9]([a-zA-Z0-9-]*[a-zA-Z0-9])?(\.[a-zA-Z0-9]([a-zA-Z0-9-]*[a-zA-Z0-9])?)*(:\d+)?\/.*$
Required: {}
backendRef BackendRefThe Backend representing the Json Web Key Set serverRequired: {}
cacheDuration DurationDuration after which the cached JWKS should be expired.
If not specified, default cache duration is 5 minutes.
Optional: {}
asyncFetch JwksAsyncFetchFetch Jwks asynchronously in the main thread before the listener is activated.
Fetched Jwks can be used by all worker threads.
If this feature is not enabled:
- The Jwks is fetched on-demand when the requests come. During the fetching, first
few requests are paused until the Jwks is fetched.
- Each worker thread fetches its own Jwks since Jwks cache is per worker thread.
If this feature is enabled:
- Fetched Jwks is done in the main thread before the listener is activated. Its fetched
Jwks can be used by all worker threads. Each worker thread doesn’t need to fetch its own.
- Jwks is ready when the requests come, not need to wait for the Jwks fetching.
Optional: {}

RequestBodyParse

Underlying type: string

RequestBodyParse determines how the body will be parsed.

Appears in:

FieldDescription
ParseAsJsonParseAsJson configures the transformation to attempt to parse the request/response body as JSON
DontParseDontParse configures the transformation so that the request/response body is treated as plain text. The request/response is buffered, but not parsed as JSON.

RequestMatcher

RequestMatcher configures transformations to apply on the request.

Appears in:

FieldDescriptionDefaultValidation
matcher TransformationRequestMatcherMatcher defines the request matching parameter. Only when the match is satisfied, the “requires” field will
apply.
Matches define conditions used for matching the rule against incoming
HTTP requests. Each match is independent, i.e. this rule will be matched
if any one of the matches is satisfied.
For example, take the following matches configuration:
<br />matches:<br />- path:<br /> value: "/foo"<br /> headers:<br /> - name: "version"<br /> value "v1"<br />- path:<br /> value: "/v2/foo"<br />
For a request to match against this rule, a request must satisfy
EITHER of the two conditions:
- path prefixed with /foo AND contains the header version: v1
- path prefix of /v2/foo
For example: following match will match all requests.
matches:
- path:
value: “/”
AtMostOneOf: [prefix path regex connect]
Optional: {}
clearRouteCache booleanClearRouteCache should we clear the route cache if a transformation was matched.Optional: {}
transformation TransformationTransformation to apply on the request.ExactlyOneOf: [template headerBody]
Required: {}

RequestResponseTransformations

RequestResponseTransformations configures transformations to apply on the request and response.

Appears in:

FieldDescriptionDefaultValidation
requests RequestMatcher arrayRequests configures transformations to apply on the request. The first request that matches will apply.MaxItems: 32
Optional: {}
responses ResponseMatcher arrayResponses configures transformations to apply on the response. The first response transformation that
matches will apply.
MaxItems: 32
Optional: {}

ResponseMatcher

ResponseMatch configures transformations to apply on the response.

Appears in:

FieldDescriptionDefaultValidation
matchers TransformationHeaderMatcher arraySpecifies a set of headers that the route should match on. The router will
check the response headers against all the specified headers in the route
config. A match will happen if all the headers in the route are present in
the request with the same values (or based on presence if the value field
is not in the config).
MaxItems: 32
Optional: {}
responseCodeDetails stringOnly match responses with non-empty response code details (this usually
implies a local reply).
Optional: {}
transformation TransformationTransformation to apply on the response.ExactlyOneOf: [template headerBody]
Required: {}

SpanTransformer

SpanTransformer defines a span transformer for modifying trace spans.

Appears in:

FieldDescriptionDefaultValidation
name InjaTemplateName specifies a template that sets the span name.Required: {}

StagedJWT

StagedJWT allows for configuring JWT authentication at various stages of request processing

Appears in:

FieldDescriptionDefaultValidation
afterExtAuth EntJWTJWT configuration to be enforced after external auth has been processed (if it is present).Optional: {}
beforeExtAuth EntJWTJWT configuration to be enforced before external auth has been processed.Optional: {}

StagedTransformations

StagedTransformations configures transformations to apply for different stages of the filter chain.

Appears in:

FieldDescriptionDefaultValidation
early RequestResponseTransformationsEarly transformations happen before most other options (Like Auth and Rate Limit).Optional: {}
regular RequestResponseTransformationsRegular transformations happen after Auth and Rate limit decisions have been made.Optional: {}
postRouting RequestResponseTransformationsPostRouting happen during the router filter chain. This is important for a number of reasons
1. Retries re-trigger this filter, which might impact performance.
2. It is the only point where endpoint metadata is available.
3. clearRouteCache does NOT work in this stage as the routing decision is already made.
Optional: {}
logRequestResponseInfo booleanWhen enabled, log request/response body and headers before and after all transformations defined here are applied.<br />This overrides the logRequestResponseInfo field in the Transformation message.Optional: {}
escapeCharacters EscapeCharactersBehaviorEscapeCharacters configures the Inja behavior when rendering strings which contain
characters that would need to be escaped to be valid JSON. Note that this
sets the behavior for all staged transformations configured here. This setting
can be overridden per-transformation using the field escapeCharacters on
the TransformationTemplate.
Enum: [Escape DontEscape]
Optional: {}

TlsContextMatchOptions

TlsContextMatchOptions configures the TLS context match options.

Appears in:

FieldDescriptionDefaultValidation
presented booleanIf specified, the route will match against whether a certificate is presented.
If not specified, certificate presentation status (true or false) will not be considered when route matching.
Optional: {}
validated booleanIf specified, the route will match against whether a certificate is validated.
If not specified, certificate validation status (true or false) will not be considered when route matching.
Optional: {}

TokenSource

Describes the location of a JWT token

Appears in:

FieldDescriptionDefaultValidation
headers TokenSourceHeaderSource arrayTry to retrieve token from these headersOptional: {}
queryParams string arrayTry to retrieve token from these query paramsOptional: {}

TokenSourceHeaderSource

Describes how to retrieve a JWT from a header

Appears in:

FieldDescriptionDefaultValidation
header stringThe name of the header. for example, “authorization”Required: {}
prefix stringPrefix before the token. for example, “Bearer "Optional: {}

Transformation

Transformation defines a transformation that can be applied to requests or responses.

Validation:

  • ExactlyOneOf: [template headerBody]

Appears in:

FieldDescriptionDefaultValidation
template TransformationTemplateTemplate specifies a template-based transformation.Optional: {}
headerBody HeaderBodyTransformHeaderBody specifies a header and body transformation.Optional: {}

TransformationExtractMode

Underlying type: string

TransformationExtractMode represents the mode of operation for the extraction, which configures how the transformation will extract the content of a specified capturing group.

Validation:

  • Enum: [Extract SingleReplace ReplaceAll]

Appears in:

FieldDescription
ExtractModeExtract configures the transformation to extract the content of a specified capturing group. In this mode,
subgroup selects the n-th capturing group, which represents the value that
you want to extract.
SingleReplaceModeSingleReplace configures the transformation to replace the content of a specified capturing group. In this mode, subgroup selects the
n-th capturing group, which represents the value that you want to replace with
the string provided in replacementText.
Note: replacementText must be set for this mode.
ReplaceAllModeReplaceAll configures the transformation to replace all regex matches with the value provided in replacementText.
Note: replacementText must be set for this mode.
Note: The configuration fails if subgroup is set to a non-zero value.
Note: restrictions on the regex are different for this mode. See the regex field for more details.

TransformationHeaderMatcher

TransformationHeaderMatcher configures the header matching to apply.

Appears in:

FieldDescriptionDefaultValidation
name stringSpecifies the name of the header in the request.Required: {}
value stringSpecifies the value of the header. If the value is absent a request that
has the name header will match, regardless of the header’s value.
Optional: {}
regex booleanSpecifies whether the header value should be treated as regex or not.Optional: {}
invertMatch booleanIf set to true, the result of the match will be inverted. Defaults to false.
Examples:
* name=foo, invertMatch=true: matches if no header named foo is present
* name=foo, value=bar, invertMatch=true: matches if no header named foo with value bar is present
* name=foo, value=\d\{3\}, regex=true, invertMatch=true: matches if no header named foo with a value consisting of three integers is present
Optional: {}

TransformationRequestMatcher

TransformationRequestMatcher configures the matcher to match against the request.

Validation:

  • AtMostOneOf: [prefix path regex connect]

Appears in:

FieldDescriptionDefaultValidation
prefix stringPrefix configures the prefix rule meaning that the prefix must
match the beginning of the :path header.
Max length is following https://gateway-api.sigs.k8s.io/reference/spec/#httppathmatch
MaxLength: 1024
MinLength: 1
Optional: {}
path stringPath configures the exact path rule meaning that the path must
exactly match the :path header once the query string is removed.
Max length is following https://gateway-api.sigs.k8s.io/reference/spec/#httppathmatch
MaxLength: 1024
MinLength: 1
Optional: {}
regex RegexMatcherRegex configures the route regular expression rule meaning that the
regex must match the :path header once the query string is removed. The entire path
(without the query string) must match the regex. The rule will not match if only a
subsequence of the :path header matches the regex.
Optional: {}
connect booleanConnect configures the matcher to only match CONNECT requests.
Note that this will not match HTTP/2 upgrade-style CONNECT requests
(WebSocket and the like) as they are normalized in Envoy as HTTP/1.1 style
upgrades.
This is the only way to match CONNECT requests for HTTP/1.1. For HTTP/2,
where CONNECT requests may have a path, the path matchers will work if
there is a path present.
Optional: {}
caseSensitive booleanCaseSensitive indicates that prefix/path matching should be case-insensitive. The default
is true.
trueOptional: {}
headers TransformationHeaderMatcher arraySpecifies a set of headers that the route should match on. The router will
check the request’s headers against all the specified headers in the route
config. A match will happen if all the headers in the route are present in
the request with the same values (or based on presence if the value field
is not in the config).
MaxItems: 32
Optional: {}
queryParameters QueryParameterMatcher arraySpecifies a set of URL query parameters on which the route should
match. The router will check the query string from the path header
against all the specified query parameters. If the number of specified
query parameters is nonzero, they all must match the path header’s
query string for a match to occur.
MaxItems: 32
Optional: {}
grpc booleanIf specified, only gRPC requests will be matched. The router will check
that the content-type header has a application/grpc or one of the various
application/grpc+ values.
Optional: {}
tlsContext TlsContextMatchOptionsIf specified, the client tls context will be matched against the defined
match options.
Optional: {}
methods string arrayHTTP Method/Verb(s) to match on. If none specified, the matcher will ignore the HTTP MethodMaxItems: 32
Optional: {}

TransformationTemplate

TransformationTemplate defines a transformation template.

Appears in:

FieldDescriptionDefaultValidation
advancedTemplates booleanAdvancedTemplates determines whether to use JSON pointer notation instead of dot notation.
If set to true, use JSON pointer notation (e.g. “time/start”) instead of
dot notation (e.g. “time.start”) to access JSON elements. Defaults to
false.
Please note that, if set to ’true’, you will need to use the extraction
function to access extractors in the template (e.g. “{{ extraction(“my_extractor”) }}”).
If the default value of ‘false’ is used, extractors will simply be available by their name (e.g. “{{ my_extractor }}”).
Optional: {}
extractors object (keys:string, values:Extraction)Extractors use this attribute to extract information from the request. It consists of
a map of strings to extractors. The extractor will define which
information will be extracted, while the string key will provide the
extractor with a name. You can reference extractors by their name in
templates, e.g. “{{ my-extractor }}” will render to the value of the
“my-extractor” extractor.
MaxProperties: 32
Optional: {}
headers object (keys:string, values:InjaTemplate)Headers configures the transform request/response headers. It consists of a
map of strings to templates. The string key determines the name of the
resulting header, the rendered template will determine the value. Any existing
headers with the same header name will be replaced by the transformed header.
If a header name is included in headers and headersToAppend, it will first
be replaced the template in headers, then additional header values will be appended
by the templates defined in headersToAppend.
For example, the following header transformation configuration:
yaml<br /> headers:<br /> x-header-one: \{"text": "first \{\{inja\}\} template"\}<br /> x-header-one: \{"text": "second \{\{inja\}\} template"\}<br /> headersToAppend:<br /> - key: x-header-one<br /> value: \{"text": "first appended \{\{inja\}\} template"\}<br /> - key: x-header-one<br /> value: \{"text": "second appended \{\{inja\}\} template"\}<br />
will result in the following headers on the HTTP message:
<br />x-header-one: first inja template<br />x-header-one: first appended inja template<br />x-header-one: second appended inja template<br />
MaxProperties: 32
Optional: {}
headersToAppend HeaderToAppend arrayHeadersToAppend configures the transform request/response headers. It consists of
an array of string/template objects. Use this attribute to define multiple
templates for a single header. Header template(s) defined here will be appended to any
existing headers with the same header name, not replace existing ones.
See headers documentation to see an example of usage.
MaxItems: 32
Optional: {}
headersToRemove string arrayHeadersToRemove is configured to remove headers from requests. If a header is present multiple
times, all instances of the header will be removed.
MaxItems: 32
Optional: {}
bodyTransformation BodyTransformationBodyTransformation specifies how to transform the body.AtMostOneOf: [body mergeJsonKeys]
Optional: {}
parseBodyBehavior RequestBodyParseParseBodyBehavior determines how the body will be parsed. Defaults to ParseAsJson.ParseAsJsonEnum: [ParseAsJson DontParse]
Optional: {}
ignoreErrorOnParse booleanIgnoreErrorOnParse determines whether Envoy should throw an exception if body parsing fails.Optional: {}
dynamicMetadataValues DynamicMetadataValue arrayDynamicMetadataValues defines Envoy Dynamic Metadata entries.MaxItems: 32
Optional: {}
escapeCharacters EscapeCharactersBehaviorEscapeCharacters configures the Inja behavior when rendering strings which contain
characters that would need to be escaped to be valid JSON. Note that this
sets the behavior for the entire transformation. Use raw_strings function
for fine-grained control within a template.
Enum: [Escape DontEscape]
Optional: {}
spanTransformer SpanTransformerSpanTransformer defines a span transformer for modifying trace spans.Optional: {}

WAFAdminConfiguration

Appears in:

FieldDescriptionDefaultValidation
enabled booleanEnabled indicates whether the admin server is enabled. If not enabled, then no admin server will be deployed.
Defaults to false.
Optional: {}

WAFConfiguration

Appears in:

FieldDescriptionDefaultValidation
enabled boolean(Inherited from DeploymentConfiguration) Enabled indicates whether the extension is enabled. If not enabled, then no resources for this extension will be deployed.
If the extension was previously enabled and then disabled, the deployed resources will be garbage collected, regardless of
whether any other configuration still depends on it.
Optional: {}
resources ResourceRequirements(Inherited from DeploymentConfiguration)Optional: {}
pod Pod(Inherited from DeploymentConfiguration)Optional: {}
container ContainerConfiguration(Inherited from DeploymentConfiguration)Optional: {}
replicas integer(Inherited from DeploymentConfiguration) The number of desired pods.
If omitted, behavior will be managed by the K8s control plane, and will default to 1.
If you are using an HPA, make sure to not explicitly define this.
K8s reference: https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#replicas
Minimum: 0
Optional: {}
strategy DeploymentStrategy(Inherited from DeploymentConfiguration) The deployment strategy to use to replace existing pods with new
ones. The Kubernetes default is a RollingUpdate with 25% maxUnavailable,
25% maxSurge.
E.g., to recreate pods, minimizing resources for the rollout but causing downtime:
strategy:
type: Recreate
E.g., to roll out as a RollingUpdate but with non-default parameters:
strategy:
type: RollingUpdate
rollingUpdate:
maxSurge: 100%
Optional: {}
deploymentOverlay KubernetesResourceOverlay(Inherited from DeploymentConfiguration) DeploymentOverlay allows specifying overrides for the generated Deployment resource.
Use this for advanced customization not covered by the typed config fields,
such as adding initContainers, sidecars, or removing security contexts for OpenShift.
Optional: {}
serviceOverlay KubernetesResourceOverlay(Inherited from DeploymentConfiguration) ServiceOverlay allows specifying overrides for the generated Service resource.Optional: {}
serviceAccountOverlay KubernetesResourceOverlay(Inherited from DeploymentConfiguration) ServiceAccountOverlay allows specifying overrides for the generated ServiceAccount resource.Optional: {}
podDisruptionBudget KubernetesResourceOverlay(Inherited from DeploymentConfiguration) PodDisruptionBudget allows creating a PodDisruptionBudget for this extension.
If absent, no PDB is created. If present, a PDB is created with its selector
automatically configured to target the extension Deployment.
The metadata and spec fields from this overlay are applied to the generated PDB.
Optional: {}
horizontalPodAutoscaler KubernetesResourceOverlay(Inherited from DeploymentConfiguration) HorizontalPodAutoscaler allows creating a HorizontalPodAutoscaler for this extension.
If absent, no HPA is created. If present, an HPA is created with its scaleTargetRef
automatically configured to target the extension Deployment.
The metadata and spec fields from this overlay are applied to the generated HPA.
Optional: {}
verticalPodAutoscaler KubernetesResourceOverlay(Inherited from DeploymentConfiguration) VerticalPodAutoscaler allows creating a VerticalPodAutoscaler for this extension.
If absent, no VPA is created. If present, a VPA is created with its targetRef
automatically configured to target the extension Deployment.
The metadata and spec fields from this overlay are applied to the generated VPA.
Optional: {}
logLevel WAFLogLevelLogLevel is the log level for the WAF extproc server. If not set, defaults to “info”.Enum: [error warn info debug trace]
Optional: {}
admin WAFAdminConfigurationAdmin configures the WAF admin server.Optional: {}
metrics WAFMetricsConfigurationMetrics configures the WAF metrics endpoint.Optional: {}

WAFLogLevel

Underlying type: string

Appears in:

FieldDescription
error
warn
info
debug
trace

WAFMetricsConfiguration

Appears in:

FieldDescriptionDefaultValidation
enabled booleanEnabled indicates whether the metrics endpoint is enabled.
Defaults to true.
Optional: {}

Shared Types

The following types are defined in the shared package and used across multiple APIs.

ACLAction

Underlying type: string

ACLAction defines whether to allow or deny traffic.

Validation:

  • Enum=allow;deny

ACLDenyResponse

ACLDenyResponse customizes the response sent when a request is denied.

Validation:

  • AtLeastOneOf=statusCode;headers;blockedByHeaderName
FieldTypeDescription
statusCode*int32StatusCode is the HTTP status code returned on deny. Defaults to 403.
headers[]ACLResponseHeaderHeaders are additional response headers to attach on every deny.
blockedByHeaderName*stringBlockedByHeaderName, when set, adds a response header with this name on every deny. The header value mirrors the blocked-by dynamic metadata: the matched rule’s name, “rule” for an unnamed rule, or “default” for a default-action deny.

ACLPolicy

ACLPolicy defines IP-based access control rules evaluated on every HTTP request. The filter uses longest-prefix matching so rule order does not matter.

FieldTypeDescription
defaultActionACLActionDefaultAction is the action to take when no rule matches the client IP. Required.
rules[]ACLRuleRules is a list of IP/CIDR-based rules. Longest-prefix match wins regardless of rule order.
denyResponse*ACLDenyResponseDenyResponse customizes the HTTP response sent when a request is denied.

ACLResponseHeader

ACLResponseHeader defines a response header to include in deny responses.

FieldTypeDescription
namestringName is the header name. Required.
valuestringValue is the header value. Required.

ACLRule

ACLRule defines an IP/CIDR-based ACL rule.

FieldTypeDescription
name*stringName is an optional rule identifier emitted as blocked-by dynamic metadata on deny.
cidrs[]IPOrCIDRCIDRs is a list of IP addresses or CIDR ranges (e.g. “10.0.0.0/8”, “2001:db8::/32”, “192.168.1.1”, “::1”). Bare IPs without a prefix are treated as /32 for IPv4 and /128 for IPv6. All entries share the same name and action. Required.
actionACLActionAction determines what to do when a client IP matches this rule. Required.

APIKeyAuth

Validation:

  • ExactlyOneOf=secretRef;secretSelector;disable
FieldTypeDescription
keySources[]APIKeySourcekeySources specifies the list of key sources to extract the API key from. Key sources are processed in array order and the first one that successfully extracts a key is used. Within each key source, if multiple types (header, query, cookie) are specified, precedence is: header > query parameter > cookie. If empty, defaults to a single key source with header “api-key”. Example: keySources: - header: “X-API-KEY” - query: “api_key” - header: “Authorization” query: “token” cookie: “auth_token” In this example, the system will: 1. First try header “X-API-KEY” 2. If not found, try query parameter “api_key” 3. If not found, try header “Authorization” (then query “token”, then cookie “auth_token” within that key source)
forwardCredential*boolforwardCredential controls whether the API key is included in the request sent to the upstream. If false (default), the API key is removed from the request before sending to upstream. If true, the API key is included in the request sent to upstream. This applies to all configured key sources (header, query parameter, or cookie).
clientIdHeader*stringclientIdHeader specifies the header name to forward the authenticated client identifier. If not specified, the client identifier will not be forwarded in any header. Example: “x-client-id”
secretRef*gwv1.SecretObjectReferencesecretRef references a Kubernetes secret storing a set of API Keys. If there are many keys, ‘secretSelector’ can be used instead. Each entry in the Secret represents one API Key. The key is an arbitrary identifier. The value is a string, representing the API Key. Example: apiVersion: v1 kind: Secret metadata: name: api-key stringData: client1: “k-123” client2: “k-456”
secretSelector*LabelSelectorsecretSelector selects multiple secrets containing API Keys. If the same key is defined in multiple secrets, the behavior is undefined. Each entry in the Secret represents one API Key. The key is an arbitrary identifier. The value is a string, representing the API Key. Example: apiVersion: v1 kind: Secret metadata: name: api-key stringData: client1: “k-123” client2: “k-456”
disable*shared.PolicyDisableDisable the API key authentication filter. Can be used to disable API key authentication policies applied at a higher level in the config hierarchy.

APIKeySource

APIKeySource defines where to extract the API key from within a single key source. Within a single key source, if multiple types are specified, precedence is: header > query parameter > cookie. The header is checked first, and only falls back to query parameter if the header is not present, then to cookie if both header and query are not present.

Validation:

  • AtLeastOneOf=header;query;cookie
FieldTypeDescription
header*stringheader specifies the name of the header that contains the API key.
query*stringquery specifies the name of the query parameter that contains the API key.
cookie*stringcookie specifies the name of the cookie that contains the API key.

AuthConfigRef

AuthConfigRef selects the AuthConfig resource with the external auth policy that you want to use. For more details, see the AuthConfig reference in the Gloo Edge docs.

FieldTypeDescription
namegwv1.ObjectNameName is the name of the AuthConfig resource. Required.
namespace*gwv1.NamespaceNamespace is the namespace of the AuthConfig resource. If not set, defaults to the namespace of the policy from which the AuthConfig is referenced.

Authorization

Authorization defines the configuration for role-based access control.

FieldTypeDescription
policyAuthorizationPolicyPolicy specifies the Authorization rule to evaluate. A policy matches when any of the conditions evaluates to true. Required.
actionAuthorizationPolicyActionAction defines whether the rule allows or denies the request if matched. If unspecified, the default is “Allow”.

AuthorizationPolicy

AuthorizationPolicy defines a single Authorization rule.

FieldTypeDescription
matchExpressions[]CELExpressionMatchExpressions defines a set of conditions that must be satisfied for the rule to match. These expression should be in the form of a Common Expression Language (CEL) expression. Required.

AuthorizationPolicyAction

Underlying type: string

AuthorizationPolicyAction defines the action to take when the RBACPolicies matches.

BasicAuthPolicy

BasicAuthPolicy configures HTTP basic authentication using the Authorization header. Basic authentication validates requests against username/password pairs provided either inline or via a Kubernetes secret. The credentials must be in htpasswd SHA-1 format.

Validation:

  • ExactlyOneOf=users;secretRef;disable
FieldTypeDescription
users[]stringUsers provides an inline list of username/password pairs in htpasswd format. Each entry should be formatted as “username:hashed_password”. The only supported hash format is SHA-1 Example entries: - “user1:{SHA}d95o2uzYI7q7tY7bHI4U1xBug7s=”
secretRef*SecretReferenceSecretRef references a Kubernetes secret containing htpasswd data. The secret must contain username/password pairs in htpasswd format.
disable*shared.PolicyDisableDisable basic auth. Can be used to disable basic auth policies applied at a higher level in the config hierarchy.

BodyTransformation

BodyTransformation controls how the body should be parsed and transformed.

FieldTypeDescription
parseAsBodyParseBehaviorParseAs defines what auto formatting should be applied to the body. This can make interacting with keys within a json body much easier if AsJson is selected. When set to None, it will not buffer the body and will skip all body processing. In addition, attempt to extract json variables from the body using inja template in the header will result in 400 response.
value*InjaTemplateValue is the template to apply to generate the output value for the body. Only Inja templates are supported. If ParseAs field is set to None, this Value field is ignored and no body transformation will be done.

BodyTransformation (Enterprise)

BodyTransformation defines how to transform the body.

Validation:

  • XValidation:rule=“self.type == ‘Body’ ? has(self.body) : true”,message=“body must be set when type is Body”
  • XValidation:rule=“self.type == ‘MergeJsonKeys’ ? has(self.mergeJsonKeys) : true”,message=“mergeJsonKeys must be set when type is MergeJsonKeys”
  • AtMostOneOf=body;mergeJsonKeys
FieldTypeDescription
typeBodyTransformationTypeType specifies the type of body transformation to apply. Required.
body*InjaTemplateBody is the request/response body to be transformed. Only use when Type is Body.
mergeJsonKeysmap[string]OverridableTemplateMergeJsonKeys is a transformation template used to merge json keys. Only use when Type is MergeJsonKeys. A set of key-value pairs to merge into the JSON body. Each value will be rendered separately, and then placed into the JSON body at the specified key. There are a number of important caveats to using this feature: * This can only be used when the body is parsed as JSON. * This option does NOT work with advanced templates currently Map of key name -> template to render into the JSON body. Specified keys which don’t exist in the JSON body will be set, keys which do exist will be override. For example, given the following JSON body: { “key1”: “value1” } and the following MergeJsonKeys: { “key1”: “{{ header(“header1”) }}”, “key2”: “{{ header(“header2”) }}” } The resulting JSON body will be: { “key1”: “header1_value”, “key2”: “header2_value” }

BodyTransformationType

Underlying type: string

BodyTransformationType defines the type of body transformation to apply.

Validation:

  • Enum=Body;Passthrough;MergeExtractorsToBody;MergeJsonKeys

Buffer

Validation:

  • ExactlyOneOf=maxRequestSize;disable
FieldTypeDescription
maxRequestSize*resource.QuantityMaxRequestSize sets the maximum size in bytes of a message body to buffer. Requests exceeding this size will receive HTTP 413. Example format: “1Mi”, “512Ki”, “1Gi”
disable*shared.PolicyDisableDisable the buffer filter. Can be used to disable buffer policies applied at a higher level in the config hierarchy.

CELExpression

Underlying type: string

CELExpression represents a Common Expression Language (CEL) expression.

Validation:

  • MinLength=1
  • MaxLength=16384

CSRFPolicy

CSRFPolicy can be used to set percent of requests for which the CSRF filter is enabled, enable shadow-only mode where policies will be evaluated and tracked, but not enforced and add additional source origins that will be allowed in addition to the destination origin.

Validation:

  • AtMostOneOf=percentageEnabled;percentageShadowed
FieldTypeDescription
percentageEnabled*int32Specifies the percentage of requests for which the CSRF filter is enabled.
percentageShadowed*int32Specifies that CSRF policies will be evaluated and tracked, but not enforced.
additionalOrigins[]shared.StringMatcherSpecifies additional source origins that will be allowed in addition to the destination origin.

Compression

Compression configures HTTP response compression and request decompression behavior.

Validation:

  • AtLeastOneOf=responseCompression;requestDecompression
FieldTypeDescription
responseCompression*ResponseCompressionResponseCompression controls response compression to the downstream. If set, responses with a matching Accept-Encoding header and certain textual content types will be compressed. The compression codecs default to gzip and can be selected via responseCompression.libraries, which Envoy negotiates against the request’s Accept-Encoding header. The content-types that will be compressed are: - application/javascript - application/json - application/xhtml+xml - image/svg+xml - text/css - text/html - text/plain - text/xml
requestDecompression*RequestDecompressionRequestDecompression controls request decompression. If set, request bodies in the configured codecs are decompressed before forwarding.

CompressionLibrary

Underlying type: string

CompressionLibrary identifies a compression codec used to compress responses or decompress requests.

Validation:

  • Enum=Gzip;Brotli;Zstd

CorsPolicy

Inherits fields from:

FieldTypeDescription
disable*shared.PolicyDisableDisable the CORS filter. Can be used to disable CORS policies applied at a higher level in the config hierarchy.

CustomAttribute

Describes attributes for the active span. Ref: https://www.envoyproxy.io/docs/envoy/latest/api-v3/type/tracing/v3/custom_tag.proto#envoy-v3-api-msg-type-tracing-v3-customtag

Validation:

  • MaxProperties=2
  • MinProperties=1
FieldTypeDescription
namestringThe name of the attribute Required.
literal*CustomAttributeLiteralA literal attribute value.
environment*CustomAttributeEnvironmentAn environment attribute value.
requestHeader*CustomAttributeHeaderA request header attribute value.
metadata*CustomAttributeMetadataAn attribute to obtain the value from the metadata.

CustomAttributeEnvironment

Environment type attribute with environment name and default value. Ref: https://www.envoyproxy.io/docs/envoy/latest/api-v3/type/tracing/v3/custom_tag.proto#type-tracing-v3-customtag-environment

FieldTypeDescription
namestringEnvironment variable name to obtain the value to populate the attribute value. Required.
defaultValue*stringWhen the environment variable is not found, the attribute value will be populated with this default value if specified, otherwise no attribute will be populated.

CustomAttributeHeader

Header type attribute with header name and default value. https://www.envoyproxy.io/docs/envoy/latest/api-v3/type/tracing/v3/custom_tag.proto#type-tracing-v3-customtag-header

FieldTypeDescription
namestringHeader name to obtain the value to populate the attribute value. Required.
defaultValue*stringWhen the header does not exist, the attribute value will be populated with this default value if specified, otherwise no attribute will be populated.

CustomAttributeLiteral

Literal type attribute with a static value. Ref: https://www.envoyproxy.io/docs/envoy/latest/api-v3/type/tracing/v3/custom_tag.proto#type-tracing-v3-customtag-literal

FieldTypeDescription
valuestringStatic literal value to populate the attribute value. Required.

CustomAttributeMetadata

Metadata type attribute using MetadataKey to retrieve the protobuf value from Metadata, and populate the attribute value with the canonical JSON representation of it. Ref: https://www.envoyproxy.io/docs/envoy/latest/api-v3/type/tracing/v3/custom_tag.proto#type-tracing-v3-customtag-metadata

FieldTypeDescription
kindMetadataKindSpecify what kind of metadata to obtain attribute value from Required.
metadataKeyMetadataKeyMetadata key to define the path to retrieve the attribute value. Required.
defaultValue*stringWhen no valid metadata is found, the attribute value would be populated with this default value if specified, otherwise no attribute would be populated.

DnsResolver

DnsResolver configures the CARES DNS resolver for Envoy.

FieldTypeDescription
udpMaxQueries*int32Maximum number of UDP queries to be issued on a single UDP channel. This helps prevent DNS query pinning to a single resolver, addressing the issue described in https://github.com/istio/istio/issues/53577. Defaults to 100 if not specified. Set to 0 to disable this limit. See https://www.envoyproxy.io/docs/envoy/latest/api-v3/extensions/network/dns_resolver/cares/v3/cares_dns_resolver.proto#extensions-network-dns-resolver-cares-v3-caresdnsresolverconfig

DynamicMetadataTransformation

DynamicMetadataTransformation defines a single dynamic metadata entry to set.

FieldTypeDescription
namespacestringNamespace is the dynamic metadata namespace. Required.
keystringKey is the metadata key within the namespace. Required.
valueDynamicMetadataValueValue is the value to set in dynamic metadata. Required.

DynamicMetadataValue

DynamicMetadataValue defines the value to set in dynamic metadata. Exactly one field must be set.

Validation:

  • ExactlyOneOf=stringValue
FieldTypeDescription
stringValue*InjaTemplateStringValue is an Inja template whose rendered output is stored as the metadata string value.

DynamicMetadataValue (Enterprise)

DynamicMetadataValue defines an Envoy Dynamic Metadata entry.

FieldTypeDescription
metadataNamespace*stringMetadataNamespace specifies the metadata namespace. Defaults to the filter namespace.
keystringKey specifies the metadata key. Required.
valueInjaTemplateValue specifies the template that determines the metadata value. Required.
jsonToProto*boolJsonToProto determines whether to parse the rendered value as a proto Struct message.

EnvoyBootstrap

EnvoyBootstrap configures the Envoy proxy instance that is provisioned from a Kubernetes Gateway.

FieldTypeDescription
logFormat*LogFormatEnvoy application log format. Does not affect access logs. Can be JSON or custom text format. Defaults to text with default format string as defined in Envoy documentation. See https://www.envoyproxy.io/docs/envoy/latest/operations/cli#cmdoption-log-format for format flag options.
logLevel*stringEnvoy log level. Options include “trace”, “debug”, “info”, “warn”, “error”, “critical” and “off”. Defaults to “info”. See https://www.envoyproxy.io/docs/envoy/latest/start/quick-start/run-envoy#debugging-envoy for more information.
componentLogLevelsmap[string]stringEnvoy log levels for specific components. The keys are component names and the values are one of “trace”, “debug”, “info”, “warn”, “error”, “critical”, or “off”, e.g. yaml componentLogLevels: upstream: debug connection: trace These will be converted to the --component-log-level Envoy argument value. See https://www.envoyproxy.io/docs/envoy/latest/start/quick-start/run-envoy#debugging-envoy for more information. Note: the keys and values cannot be empty, but they are not otherwise validated.
dnsResolver*DnsResolverDNS resolver configuration for Envoy’s CARES DNS resolver. This configuration applies to all clusters and affects DNS query behavior. See https://www.envoyproxy.io/docs/envoy/latest/api-v3/extensions/network/dns_resolver/cares/v3/cares_dns_resolver.proto for more information.
enableReadinessProbeProxyProtocol*boolEnableReadinessProbeProxyProtocol enables the PROXY protocol listener filter on the kgateway readiness listener (port 8082). Set this to true if and only if the load balancer in front of the gateway prepends PROXY protocol headers to incoming TCP connections targeting the readiness port. For example, when using an AWS NLB with proxy protocol v2 enabled at the target group level (service.beta.kubernetes.io/aws-load-balancer-proxy-protocol: "*"). Defaults to false.

EnvoyContainer

EnvoyContainer configures the container running Envoy.

FieldTypeDescription
bootstrap*EnvoyBootstrapInitial envoy configuration.
image*ImageThe envoy container image. See https://kubernetes.io/docs/concepts/containers/images for details. Default values, which may be overridden individually: registry: quay.io/solo-io repository: envoy-wrapper tag: pullPolicy: IfNotPresent
securityContext*corev1.SecurityContextThe security context for this container. See https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.26/#securitycontext-v1-core for details.
resources*corev1.ResourceRequirementsThe compute resources required by this container. See https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/ for details.
extraArgs[]stringAdditional arguments to pass to the Envoy binary. Similar to Kubernetes container args, variable references $(VAR_NAME) are expanded using the container’s environment. If a variable cannot be resolved, the reference is left unchanged. Double $$ are reduced to a single $, which allows escaping the $(VAR_NAME) syntax. The following Envoy flags are already managed by kgateway and must not be set here: --disable-hot-restart, --service-node, --log-level, and --component-log-level. Consider using a DeploymentOverlay to override these values if desired.
env[]corev1.EnvVarThe container environment variables.
extraVolumeMounts[]corev1.VolumeMountAdditional volume mounts to add to the container. See https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.26/#volumemount-v1-core for details.

ExtAuthBufferSettings

ExtAuthBufferSettings configures how the request body should be buffered.

FieldTypeDescription
maxRequestBytesint32MaxRequestBytes sets the maximum size of a message body to buffer. Requests exceeding this size will receive HTTP 413 and not be sent to the auth service. Required.
allowPartialMessageboolAllowPartialMessage determines if partial messages should be allowed. When true, requests will be sent to the auth service even if they exceed maxRequestBytes. The default behavior is false.
packAsBytesboolPackAsBytes determines if the body should be sent as raw bytes. When true, the body is sent as raw bytes in the raw_body field. When false, the body is sent as UTF-8 string in the body field. The default behavior is false.

ExtAuthPolicy

ExtAuthPolicy configures external authentication/authorization for a route. This policy will determine the ext auth server to use and how to talk to it. Note that most of these fields are passed along as is to Envoy. For more details on particular fields please see the Envoy ExtAuth documentation. https://raw.githubusercontent.com/envoyproxy/envoy/f910f4abea24904aff04ec33a00147184ea7cffa/api/envoy/extensions/filters/http/ext_authz/v3/ext_authz.proto

Validation:

  • ExactlyOneOf=extensionRef;disable
FieldTypeDescription
extensionRef*shared.NamespacedObjectReferenceExtensionRef references the GatewayExtension that should be used for auth.
withRequestBody*ExtAuthBufferSettingsWithRequestBody allows the request body to be buffered and sent to the auth service. Warning buffering has implications for streaming and therefore performance.
contextExtensionsmap[string]stringAdditional context for the auth service.
disable*shared.PolicyDisableDisable all external auth filters. Can be used to disable external auth policies applied at a higher level in the config hierarchy.

ExtProcPolicy

ExtProcPolicy defines the configuration for the Envoy External Processing filter.

Validation:

  • ExactlyOneOf=extensionRef;disable
FieldTypeDescription
extensionRef*shared.NamespacedObjectReferenceExtensionRef references the GatewayExtension that should be used for external processing.
processingMode*ProcessingModeProcessingMode defines how the filter should interact with the request/response streams
disable*shared.PolicyDisableDisable all external processing filters. Can be used to disable external processing policies applied at a higher level in the config hierarchy.

FaultAbort

FaultAbort configures request abort injection.

Validation:

  • ExactlyOneOf=httpStatus;grpcStatus
FieldTypeDescription
httpStatus*int32HttpStatus is the HTTP status code to return when aborting a request.
grpcStatus*int32GrpcStatus is the gRPC status code to return when aborting a request.
percentage*int32Percentage of requests to abort. Defaults to 100.

FaultDelay

FaultDelay configures latency injection.

FieldTypeDescription
fixedDelaymetav1.DurationFixedDelay is the duration to delay before forwarding the request. Required.
percentage*int32Percentage of requests to inject the delay on. Defaults to 100.

FaultInjectionPolicy

FaultInjectionPolicy configures fault injection for testing service resiliency. At least one of delay, abort, responseRateLimit, or disable must be specified.

Validation:

  • AtLeastOneOf=delay;abort;responseRateLimit;disable
FieldTypeDescription
delay*FaultDelayDelay injects latency into requests before forwarding upstream.
abort*FaultAbortAbort injects HTTP or gRPC errors to terminate requests early.
responseRateLimit*FaultResponseRateLimitResponseRateLimit limits the response body data rate to simulate slow or degraded upstream connections.
maxActiveFaults*uint32MaxActiveFaults limits the number of concurrent active faults. When this limit is reached, new requests will not have faults injected. If not specified, defaults to unlimited.
disable*shared.PolicyDisableDisable the fault injection filter. Can be used to disable fault injection policies applied at a higher level in the config hierarchy.

FaultResponseRateLimit

FaultResponseRateLimit configures response body rate limiting to simulate slow upstream connections.

FieldTypeDescription
kbitsPerSeconduint64KbitsPerSecond limits the response rate to the specified kilobits per second. Required.
percentage*int32Percentage of requests to apply the rate limit on. Defaults to 100.

GracefulShutdownSpec

FieldTypeDescription
enabled*boolEnable grace period before shutdown to finish current requests. When enabled, a preStop hook calls /healthcheck/fail on Envoy’s admin port, which causes the /ready endpoint to return 503 (DRAINING). This makes the Kubernetes readiness probe fail, removing the pod from Service endpoints so new traffic stops arriving (unless all endpoints are draining – see KEP-1669: Proxy Terminating Endpoints). The hook then sleeps for SleepTimeSeconds to allow in-flight requests to complete.
sleepTimeSeconds*int64Time (in seconds) for the preStop hook to wait before allowing Envoy to terminate

HTTPHeader

HTTPHeader represents a single header name/value pair. Exactly one of value or secretRef must be set. When using secretRef, name and key interact as follows: - Both present: name is the header name, key is the Secret data key. - name absent, key present: the key is also used as the header name. - name present, key absent: the name is also used as the Secret data key. - Both absent: every entry in the Secret is injected as a header (data key -> header name).

Validation:

  • ExactlyOneOf=value;secretRef
  • XValidation:rule=“has(self.value) ? has(self.name) : true”,message=“name is required when using an inline value”
FieldTypeDescription
name*gwv1.HTTPHeaderNameName is the HTTP header field name. Name matching is case-insensitive. (See https://tools.ietf.org/html/rfc7230#section-3.2.) Required when value is set. When secretRef is used, if omitted the Secret data key is used as the header name; if both name and key are omitted every Secret entry is injected as a header.
value*stringValue is an inline string value for the header. Mutually exclusive with secretRef. Must consist of printable US-ASCII characters. (See https://tools.ietf.org/html/rfc7230#section-3.2.)
secretRef*SecretRefWithKeySecretRef sources the header value from a key in a Kubernetes Secret. Mutually exclusive with value.

HTTPHeaderFilter

HTTPHeaderFilter defines a filter that modifies the headers of an HTTP request or response. Only one action for a given header name is permitted. Filters specifying multiple actions of the same or different type for any one header name are invalid and will be rejected by CRD validation. Configuration to set or add multiple values for a header must use RFC 7230 header value formatting, separating each value with a comma. Unlike the Gateway API HTTPHeaderFilter, each entry also supports sourcing the value from a Kubernetes Secret via secretRef.

Validation:

  • AtLeastOneOf=set;add;remove
FieldTypeDescription
set[]HTTPHeaderSet overwrites the request with the given header (name, value) before the action. Input: GET /foo HTTP/1.1 my-header: foo Config: set: - name: “my-header” value: “bar” Output: GET /foo HTTP/1.1 my-header: bar
add[]HTTPHeaderAdd adds the given header(s) (name, value) to the request before the action. It appends to any existing values associated with the header name. Input: GET /foo HTTP/1.1 my-header: foo Config: add: - name: “my-header” value: “bar,baz” Output: GET /foo HTTP/1.1 my-header: foo,bar,baz
remove[]stringRemove the given header(s) from the HTTP request before the action. The value of Remove is a list of HTTP header names. Note that header names are case-insensitive (see RFC 2616, Section 4.2). Input: GET /foo HTTP/1.1 my-header1: foo my-header2: bar my-header3: baz Config: remove: [“my-header1”, “my-header3”] Output: GET /foo HTTP/1.1 my-header2: bar

HeaderModifiers

HeaderModifiers can be used to define the policy to modify request and response headers.

Validation:

  • AtLeastOneOf=request;response
FieldTypeDescription
request*HTTPHeaderFilterRequest modifies request headers.
response*HTTPHeaderFilterResponse modifies response headers.

HeaderName

Underlying type: string

EnvoyHeaderName is the name of a header or pseudo header Based on gateway api v1.Headername but allows a singular : at the start

Validation:

  • MinLength=1
  • MaxLength=256
  • Pattern=^:?[A-Za-z0-9!#$%&'*+\-.^_\x60|~]+$

HeaderTransformation

EnvoyHeaderName is the name of a header or pseudo header Based on gateway api v1.Headername but allows a singular : at the start

Validation:

  • MinLength=1
  • MaxLength=256
  • Pattern=^:?[A-Za-z0-9!#$%&'*+\-.^_\x60|~]+$
FieldTypeDescription
nameHeaderNameRequired.
valueInjaTemplate

IPOrCIDR

Underlying type: string

IPOrCIDR accepts either a bare IP address or an address range in CIDR notation. A bare IP without a prefix length is treated as /32 for IPv4 and /128 for IPv6. Note: The regex for the IP validation patterns was taken from https://www.ditig.com/validating-ipv4-and-ipv6-addresses-with-regexp

Validation:

  • Pattern=^((25[0-5]|(2[0-4]|1\d|[1-9]|)\d)\.?\b){4}(\/([0-9]|[1-2][0-9]|3[0-2]))?$|^((?:[0-9A-Fa-f]{1,4}:){7}[0-9A-Fa-f]{1,4}|(?:[0-9A-Fa-f]{1,4}:){1,7}:|:(?::[0-9A-Fa-f]{1,4}){1,7}|(?:[0-9A-Fa-f]{1,4}:){1,6}:[0-9A-Fa-f]{1,4}|(?:[0-9A-Fa-f]{1,4}:){1,5}(?::[0-9A-Fa-f]{1,4}){1,2}|(?:[0-9A-Fa-f]{1,4}:){1,4}(?::[0-9A-Fa-f]{1,4}){1,3}|(?:[0-9A-Fa-f]{1,4}:){1,3}(?::[0-9A-Fa-f]{1,4}){1,4}|(?:[0-9A-Fa-f]{1,4}:){1,2}(?::[0-9A-Fa-f]{1,4}){1,5}|[0-9A-Fa-f]{1,4}:(?:(?::[0-9A-Fa-f]{1,4}){1,6})|:(?:(?::[0-9A-Fa-f]{1,4}){1,6}))(\/(12[0-8]|1[0-1][0-9]|[1-9][0-9]|[0-9]))?$

Image

A container image. See https://kubernetes.io/docs/concepts/containers/images for details.

FieldTypeDescription
registry*stringThe image registry.
[...]
